# Calculating Parameters:
# Author: Robert W. Buchkowski
# Created: Feb 24/2021

# Expected moose density:
# 1-7 moose/ km^2
# 1-7 moose/km^2 * 0.35 tonnes/moose * 1km^2/100ha = 
# 0.0035 - 0.0245 tonnes per hectare

# Calculate moose browsing rates: Crete 1989

Area = c(3.6,0.4,0.3,2.6,0.6,0.8,0.4,0.9) #km2
browsed = c(3.1,0.3,0.2,1,17.7,12.2,2.7,1.8) # kg_B/ha*winter
total = c(585,757,203,652,672,592,870,534) # kg_B/ha
moose = mean(c(17.5,20.3)/10) # NUMB/km2
#0.35 tonnes per moose

# moose/km2 * 0.35 tonnes/moose * 1km2/ 100 ha
# browsed divided by total as the fraction eaten per winter
# multiple by 2 because the paper measures winter browse, but the model takes annual browse rate and corrects in internally: 1 year = 2 winters in days
(mean(browsed)/1000)*(moose*0.35/100)

2*mean(browsed/total)/(moose*0.35/100)

# Calculating Balsam Fir Reproduction:
# Using data from Messaoud et al. 2007
# Data from Table 3
# THIS IS A DEAD END, YEAR 1 SURVIVAL IS VERY IMPORTANT AND NOT IN THE DATA HERE.

# Seeds per Cone:
# Weighted average by sample size each year to avoid average of averages
spc = (10*193.58 + 10*180.58 + 20*250.86 + 20*193.38)/60

# Filled seeds per seed:
# Weighted average by the average number of seeds per cone to try and get the conversion right.
fps = (47.72*10*193.58 + 49.11*10*180.58 + 85.39*20*250.86 + 29.66*20*193.38)/(193.58*10 + 180.58*10 + 250.86*20 + 193.38*20)

# Germination per filled seed:
gpf = sum(c(10,10,20,20)*c(61.44, 55.70, 75.85, 8.59)*c(47.72*193.58, 49.11*180.58, 85.39*250.86, 29.66*193.38))/sum(c(47.72*193.58, 49.11*180.58, 85.39*250.86, 29.66*193.38)*c(10,10,20,20))

# Cones per tree (2004 data from Fig. 3)
cpt = exp(mean(7,4.5)) # Over 10 years

# A good source:
# https://www.srs.fs.usda.gov/pubs/misc/ag_654/volume_1/abies/balsamea.htm
# Book to get is the one referenced there.
# Survival through the first winter is questionable. 15 cm appears to be the cut off for good survival.

# 85-99 % of seedlings die before the first winter

# Calculate the annual rate of cone production
(cpt/10)*spc*(fps/100)*(gpf/100)*0.9


# Rossi and Morin 2011 #

# Number of trees per hectare: 425
# Dominant height: 16.8 m
# Mean age: 109 years
# Height saplings: 3.6 m
# Number of saplings per hectare: 625
# DBH: 4.1 cm saplings; 20.1 cm saplings
# Max sapling recruitment: 378 saplings per hectare per year
# Find the expected weight of juvenile and adult trees using Jucker's formula

# Saplings
(0.016 + 0.093)*exp(0.204^2/2)*(3.6*1)^(2.013-0.223)

# Adults
(0.016 + 0.093)*exp(0.204^2/2)*(16.8*2.5)^(2.013-0.223)

(378*1.10216)/(425*89.55287)

# Safford 1968 could have growth rates, but I need to find the base and it is for Maine.

# Soloman and Frank 1983 Growth rates of forests:
# Percent growth of surviving balsam fir: 0 to 22 %
# Percent growth of surviving spruce: 1.7 to 13.40 %
# Estimate of 0.08 for BF and 0.06 for S is probably reasonable based on these data and using the stands with the smallest starting basal area
