# New moose data preparation
# A: Robert W. Buchkowski
# D: April 8/2022

# The output of this file is harvest rates and population size for moose on the island.

if(!require("pacman")) install.packages("pacman")
p_load(sf,tidyverse)

# Read in the moose harvest data by sex and MMA -----
harvest1 = readxl::read_excel("C:/Users/rober/Documents/Moose_Model_Original_Data/Isabelle_Mar2022/Moose_HarvbySex - All MMAs - 1997-2006_1.xls", range = 'B4:D54') %>% mutate(Year = 1997) %>%
  bind_rows(
    readxl::read_excel("C:/Users/rober/Documents/Moose_Model_Original_Data/Isabelle_Mar2022/Moose_HarvbySex - All MMAs - 1997-2006_1.xls", range = 'B60:D110') %>% mutate(Year = 1998)
  ) %>%
  bind_rows(
    readxl::read_excel("C:/Users/rober/Documents/Moose_Model_Original_Data/Isabelle_Mar2022/Moose_HarvbySex - All MMAs - 1997-2006_1.xls", range = 'B116:D165') %>% mutate(Year = 1999)
  ) %>%
  bind_rows(
    readxl::read_excel("C:/Users/rober/Documents/Moose_Model_Original_Data/Isabelle_Mar2022/Moose_HarvbySex - All MMAs - 1997-2006_1.xls", range = 'B171:D221') %>% mutate(Year = 2000)
  ) %>%
  bind_rows(
    readxl::read_excel("C:/Users/rober/Documents/Moose_Model_Original_Data/Isabelle_Mar2022/Moose_HarvbySex - All MMAs - 1997-2006_1.xls", range = 'B227:D276') %>% mutate(Year = 2001)
  ) %>%
  bind_rows(
    readxl::read_excel("C:/Users/rober/Documents/Moose_Model_Original_Data/Isabelle_Mar2022/Moose_HarvbySex - All MMAs - 1997-2006_1.xls", range = 'B282:D332') %>% mutate(Year = 2002)
  ) %>%
  bind_rows(
    readxl::read_excel("C:/Users/rober/Documents/Moose_Model_Original_Data/Isabelle_Mar2022/Moose_HarvbySex - All MMAs - 1997-2006_1.xls", range = 'B338:D388') %>% mutate(Year = 2003)
  ) %>%
  # Remove the 2004 to 2006 estimates for now
  # bind_rows(
  #   readxl::read_excel("C:/Users/rober/Documents/Moose_Model_Original_Data/Isabelle_Mar2022/Moose_HarvbySex - All MMAs - 1997-2006_1.xls", range = 'B394:D443') %>% mutate(Year = 2004)
  # ) %>%
  # bind_rows(
  #   readxl::read_excel("C:/Users/rober/Documents/Moose_Model_Original_Data/Isabelle_Mar2022/Moose_HarvbySex - All MMAs - 1997-2006_1.xls", range = 'B449:D499') %>% mutate(Year = 2005)
  # ) %>%
  # bind_rows(
  #   readxl::read_excel("C:/Users/rober/Documents/Moose_Model_Original_Data/Isabelle_Mar2022/Moose_HarvbySex - All MMAs - 1997-2006_1.xls", range = 'B505:D554') %>% mutate(Year = 2006)
  # ) %>% 
  rename(MMU = ...1) %>%
  bind_rows(
    # ADD IN THE 1996 DATA!!!
    readxl::read_excel("C:/Users/rober/Documents/Moose_Model_Original_Data/Isabelle_Mar2022/Moose_HT_1996_AdjSuccessCalc.xls", sheet = "Sheet1", range = "A5:J56") %>%
      rename(Return1 = `Lic. Return`,
             Return2 = `1st Reminder`, 
             NoReturn = `Returns`,
             Hunt1 = `Hunt (1)`,
             Hunt2 = `Hunt (2)`) %>%
      select(MMU, Sales, Return1, Return2, NoReturn, Hunt1, Hunt2) %>%
      filter(!is.na(MMU)) %>%
      mutate(Licence = "Male") %>%
      bind_rows(
        readxl::read_excel("C:/Users/rober/Documents/Moose_Model_Original_Data/Isabelle_Mar2022/Moose_HT_1996_AdjSuccessCalc.xls", sheet = "Sheet2", range = "A5:J56") %>%
          rename(Return1 = `Lic. Return`,
                 Return2 = `1st Reminder`, 
                 NoReturn = `Returns`,
                 Hunt1 = `Hunt (1)`,
                 Hunt2 = `Hunt (2)`) %>%
          select(MMU, Sales, Return1, Return2, NoReturn, Hunt1, Hunt2) %>%
          filter(!is.na(MMU)) %>%
          mutate(Licence = "Either")
      ) %>%
      bind_rows(
        readxl::read_excel("C:/Users/rober/Documents/Moose_Model_Original_Data/Isabelle_Mar2022/Moose_HT_1996_AdjSuccessCalc.xls", sheet = "Sheet3", range = "A5:J56") %>%
          rename(Return1 = `Lic. Return`,
                 Return2 = `1st Reminder`, 
                 NoReturn = `Returns`,
                 Hunt1 = `Hunt (1)`,
                 Hunt2 = `Hunt (2)`) %>%
          select(MMU, Sales, Return1, Return2, NoReturn, Hunt1, Hunt2) %>%
          filter(!is.na(MMU)) %>%
          mutate(Licence = "Non-resident")
      ) %>%
      pivot_longer(Sales:Hunt2) %>%
      mutate(value = replace_na(value, 0)) %>%
      pivot_wider() %>%
      mutate(Return = Return1 + Return2,
             Hunt = Hunt1 + Hunt2) %>%
      mutate(success = Hunt/Return) %>%
      mutate(HuntNoReturn = NoReturn*success) %>% 
      mutate(EstHunt = Hunt1 + Hunt2 + HuntNoReturn) %>%
      select(MMU, Sales, EstHunt, Licence) %>%
      mutate(EstHunt = replace_na(EstHunt, 0)) %>%
      mutate(Licence = ifelse(Licence == "Male", "Male", "Either")) %>%
      group_by(MMU, Licence) %>%
      summarize(Sales = sum(Sales), EstHunt = sum(EstHunt)) %>%
      # This step contains all the data: now convert to data for the larger analysis
      select(-Sales) %>%
      ungroup() %>%
      pivot_wider(names_from = Licence, values_from = EstHunt) %>%
      mutate(Year = 1996) %>%
      
      # Estimate Either tag is 50% female based on Isabelle's other sheets
      mutate(Male = Male + Either*0.5,
             Female = Either*0.5) %>%
      select(-Either)
  )

# Read in the data from each MMU for 2004 to 2014:

# Load the ones that I can batch:
load1v = c(14:28, 37, 39:42, "39A", 45)
load1 = vector(mode = "list", length = length(load1v))
for(i in 1:length(load1v)){
  load1[[i]] =
    readxl::read_excel("C:/Users/rober/Documents/Moose_Model_Original_Data/Isabelle_Mar2022/mooseharvestestimates2004-2014_byMMA.xls", sheet = paste0("MMU", load1v[i]), range = "Y6:Z17") %>% 
    mutate(Year = 2004:2014,
           MMU = load1v[i])
}
loada = do.call("rbind",load1)

load1v = c(2:4, 6:10)
load1 = vector(mode = "list", length = length(load1v))
for(i in 1:length(load1v)){
  load1[[i]] =
    readxl::read_excel("C:/Users/rober/Documents/Moose_Model_Original_Data/Isabelle_Mar2022/mooseharvestestimates2004-2014_byMMA.xls", sheet = paste0("MMU", load1v[i]), range = "Y7:Z18") %>% 
    mutate(Year = 2004:2014,
           MMU = load1v[i])
}
loadb = do.call("rbind",load1)

load1v = c(29:36, 38, 43, 44, 47)
load1 = vector(mode = "list", length = length(load1v))
for(i in 1:length(load1v)){
  load1[[i]] =
    readxl::read_excel("C:/Users/rober/Documents/Moose_Model_Original_Data/Isabelle_Mar2022/mooseharvestestimates2004-2014_byMMA.xls", sheet = paste0("MMU", load1v[i]), range = "T6:U17") %>% 
    mutate(Year = 2004:2014,
           MMU = load1v[i])
}
loadc = do.call("rbind",load1)

# Read others individually
harvest2 = readxl::read_excel("C:/Users/rober/Documents/Moose_Model_Original_Data/Isabelle_Mar2022/mooseharvestestimates2004-2014_byMMA.xls", sheet = "MMU1", range = "AB8:Ac19") %>% 
  mutate(Year = 2004:2014,
         MMU = 1) %>%
  bind_rows(
    readxl::read_excel("C:/Users/rober/Documents/Moose_Model_Original_Data/Isabelle_Mar2022/mooseharvestestimates2004-2014_byMMA.xls", sheet = "MMU5", range = "AB7:AC18") %>% 
      mutate(Year = 2004:2014,
             MMU = 5)
  ) %>%
  bind_rows(
    readxl::read_excel("C:/Users/rober/Documents/Moose_Model_Original_Data/Isabelle_Mar2022/mooseharvestestimates2004-2014_byMMA.xls", sheet = "MMU12", range = "Z7:AA18") %>% 
      mutate(Year = 2004:2014,
             MMU = 12)
  ) %>%
  bind_rows(
    readxl::read_excel("C:/Users/rober/Documents/Moose_Model_Original_Data/Isabelle_Mar2022/mooseharvestestimates2004-2014_byMMA.xls", sheet = "MMu13", range = "Y7:Z18") %>% 
      mutate(Year = 2004:2014,
             MMU = 13)
  ) %>%
  bind_rows(
    readxl::read_excel("C:/Users/rober/Documents/Moose_Model_Original_Data/Isabelle_Mar2022/mooseharvestestimates2004-2014_byMMA.xls", sheet = "MMU11", range = "Y7:Z18") %>% 
      mutate(Year = 2004:2014,
             MMU = 11)
  ) %>%
  mutate(MMU = paste(MMU)) %>%
  bind_rows(
    loada
  )%>%
  bind_rows(
    loadb %>% mutate(MMU = paste(MMU))
  )%>%
  bind_rows(
    loadc%>% mutate(MMU = paste(MMU))
  )

harvest3 = readxl::read_excel("C:/Users/rober/Documents/Moose_Model_Original_Data/Isabelle_Mar2022/MooseHarvest_2015.xlsx", range = "A7:AE62") %>% 
  select(MMA, Male, Female) %>%
  mutate(Year = 2015) %>%
  rename(MMU = MMA) %>%
  bind_rows(
    readxl::read_excel("C:/Users/rober/Documents/Moose_Model_Original_Data/Isabelle_Mar2022/MooseHarvest_2016_Aug2017.xlsx", range = "A7:AE62") %>% 
      select(MMA, Male, Female) %>%
      mutate(Year = 2016) %>%
      rename(MMU = MMA)
  ) %>%
  bind_rows(
    readxl::read_excel("C:/Users/rober/Documents/Moose_Model_Original_Data/Isabelle_Mar2022/MooseHarvest_2017_Sep2018.xlsx", range = "A6:AE61") %>% 
      select(MMA, Male, Female) %>%
      mutate(Year = 2017) %>%
      rename(MMU = MMA)
  ) %>%
  bind_rows(
    readxl::read_excel("C:/Users/rober/Documents/Moose_Model_Original_Data/Isabelle_Mar2022/MooseHarvest_2018_Jul2019_from Glenn.xlsx", range = "A6:AE61") %>% 
      select(MMA, Male, Female) %>%
      mutate(Year = 2018) %>%
      rename(MMU = MMA)
  ) %>%
  bind_rows(
    readxl::read_excel("C:/Users/rober/Documents/Moose_Model_Original_Data/Isabelle_Mar2022/MooseHarvest_2019_20_annotated.xlsx", range = "A6:AE61") %>% 
      select(MMA, Male, Female) %>%
      mutate(Year = 2019) %>%
      rename(MMU = MMA)
  ) %>%
  bind_rows(
    readxl::read_excel("C:/Users/rober/Documents/Moose_Model_Original_Data/Isabelle_Mar2022/MooseHarvest_2020_21_annotated.xlsx", range = "A6:AE61") %>% 
      select(MMA, Male, Female) %>%
      mutate(Year = 2020) %>%
      rename(MMU = MMA)
  )

# Combine the different file sources of harvest

harvest = harvest1 %>%
  bind_rows(harvest2) %>%
  bind_rows(harvest3) %>%
  filter(MMU %in% c(paste(1:47), "39A"))

harvest %>%
  group_by(MMU, Year) %>%
  summarise(N = n()) %>% 
  filter(N == 2) %>% View()

harvest %>%
  ggplot(aes(x = Year, y = Female)) + geom_line() + facet_wrap(~MMU)

harvest  %>%
  write_csv("Data/moose_data_over_time/moose_harvest.csv")

# Read in the moose population data from surveys and clean it up ----
readxl::read_excel("C:/Users/rober/Documents/Moose_Model_Original_Data/Isabelle_Mar2022/MooseSurvey_Hist_December2021.xlsx", sheet = "Compilation", skip = 2) %>%
  rename(AdjPopEst = `Pop. Est.(CF)`) %>%
  select(MMU, Year, AdjPopEst) %>%
  filter(!is.na(MMU)) %>%
  # Remove the two surveys that Isabelle identified as inconsistent with general methods in her email on March 22/2022
  filter(!(MMU == 24 & Year == 1984 | MMU == 24 & Year == 1983 & AdjPopEst == 802)) %>%
  write_csv("Data/moose_data_over_time/moose_arieal_surveys.csv")

read_csv("Data/moose_data_over_time/moose_arieal_surveys.csv") %>%
  ggplot(aes(x = Year, y = AdjPopEst)) + geom_line() + geom_point() + facet_wrap(.~MMU)


# Combine into harvest rates ----

# Read back in harvest rates:
harvest = read_csv("Data/moose_data_over_time/moose_harvest.csv")

# Add together 39 and 39A:
harvest = harvest %>%
  mutate(MMU = ifelse(MMU == "39A", "39", MMU)) %>%
  group_by(MMU, Year) %>%
  summarize(Male = sum(Male), Female = sum(Female)) %>%
  ungroup() %>%
  mutate(MMU = ifelse(MMU == "39", "39/39A", MMU))

# Read in population models:
mpm <- read_csv("Data/moose_population_models.csv") %>%
  pivot_longer(-MMA, names_to = "Year") %>%
  mutate(Year = as.numeric(Year)) %>%
  filter(!is.na(value))

# Read in survey results
mas <- read_csv("Data/moose_data_over_time/moose_arieal_surveys.csv")

# Compare mas and mpm:
mpm %>%
  full_join(
    mas, by = c("Year","MMA"="MMU")
  ) %>% 
  mutate(diff = abs(value - AdjPopEst)) %>% filter(diff > 1) %>% View()
# There are some differences here to consider


# Calculate two harvest rates: 1 using mpm and the other using mas ----

# Harvest rates using mpm:
harvestrate = mpm %>%
  rename(ModelPopEst = value) %>%
  full_join(
    harvest, by = c("Year", "MMA" = "MMU")
  ) %>%
  full_join(
    mas, by = c("Year", "MMA" = "MMU")
  ) %>%
  mutate(harvest_mpe = (Male + Female)/ModelPopEst,
         harvest_ape = (Male + Female)/AdjPopEst) # Male plus female kills divided by the population estimate
  

# Compare average harvest rates:
harvestrate %>%
  filter(!(is.na(harvest_mpe) & is.na(harvest_ape))) %>%
  group_by(MMA) %>%
  summarize(harvest_mpe = mean(harvest_mpe),
            harvest_ape = mean(harvest_ape, na.rm = T)) %>%
  ggplot(aes(x = harvest_ape, y = harvest_mpe)) + geom_text(aes(label = MMA)) + geom_abline(intercept = 0, slope = 1) + theme_minimal() + ylab("Harvest rate with model population estimate") + xlab("Harvest rate with field population estimate")

# Now add in a backwards projection of harvesting rate up to 1979 when we want the simulation to start:
  
# Check the logic of the back cast: harvesting is proportional to moose population size by MMA:
harvestrate %>%
  filter(!(is.na(harvest_mpe) & is.na(harvest_ape))) %>%
  ggplot(aes(x = AdjPopEst, y = harvest_ape)) + geom_point() + theme_minimal()
# Not a strong trend....

harvestrate %>%
  filter(!(is.na(harvest_mpe) & is.na(harvest_ape))) %>%
  ggplot(aes(x = AdjPopEst, y = Male + Female)) + geom_point() + theme_minimal()
# Decent relationship....

# Proportion of harvest is pretty variable
harvestrate %>% 
  filter(!(is.na(harvest_mpe) & is.na(harvest_ape))) %>%
  group_by(Year) %>%
  mutate(harvest_mpe_prop = harvest_mpe/sum(harvest_mpe)) %>%
  ggplot(aes(x = Year, y = harvest_mpe_prop, group = MMA, color = MMA)) + geom_line() + theme(legend.position = "none")

# Note a strong trend...
harvestrate %>%
  group_by(Year) %>%
  mutate(mpe_prop = ModelPopEst/sum(ModelPopEst),
         harvest_mpe_prop = harvest_mpe/sum(harvest_mpe)) %>%
  ggplot(aes(mpe_prop, harvest_mpe_prop)) + geom_point()


# Load in the total island harvest for NL:
allharvest = readxl::read_excel("C:/Users/rober/Documents/Moose_Model_Original_Data/Isabelle_Mar2022/NFsummary_lic_harvest_effort_2020.xlsx") %>%
  select(Year, all.Harvest) %>%
  filter(Year >= 1979) # Keep only the 1979 forward

harvestrate %>%
  group_by(Year) %>%
  mutate(MF = Male + Female) %>%
  summarise(MF = sum(MF, na.rm = T)) %>%
  full_join(
    allharvest
  ) %>%
  filter(MF > 0) %>%
  ggplot(aes(MF, all.Harvest, color = Year)) + geom_point() + geom_abline(intercept = 0, slope = 1)

harvestprop = harvestrate %>% 
  filter(!(is.na(harvest_mpe) & is.na(harvest_ape))) %>%
  group_by(Year) %>%
  mutate(harvest_mpe_prop = harvest_mpe/sum(harvest_mpe)) %>%
  group_by(MMA) %>%
  summarize(harvest_mpe_prop_avg = mean(harvest_mpe_prop))


allharvest = allharvest %>%
  filter(Year < 1996)

temp1 <- vector(mode = "list", length = dim(allharvest)[1])

for(i in 1:dim(allharvest)[1]){
  temp1[[i]] = harvestprop %>%
    mutate(harvest_proj = harvest_mpe_prop_avg*allharvest$all.Harvest[i], Year = allharvest$Year[i])
}  

# Combine and make projection
harvestrate2 = harvestrate %>%
  full_join(
    do.call("rbind", temp1) %>%
      select(MMA, Year, harvest_proj)
  ) %>%
  mutate(harvest_proj = ifelse(is.na(harvest_proj), harvest_mpe, harvest_proj/ModelPopEst)) %>%
  filter(!is.na(harvest_proj))


harvestrate2 %>%
  ggplot(aes(x = Year, y = harvest_proj, group = MMA)) + geom_line()

# Doesn't work...for now keep a constant harvest rate in the past, since the hind-cast is so inaccurate

harvestrate %>% write_csv("Data/moose_populationANDharvest_rate.csv")
